'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ref = exports.regex = exports.len = exports.req = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// "required" core
var req = exports.req = function req(value) {
  if (Array.isArray(value)) return !!value.length;
  if (value === undefined || value === null || value === false) {
    return false;
  }

  if (value instanceof Date) {
    // invalid date won't pass
    return !isNaN(value.getTime());
  }

  if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
    for (var _ in value) {
      return true;
    }return false;
  }

  return !!String(value).length;
};

// get length in type-agnostic way
var len = exports.len = function len(value) {
  if (Array.isArray(value)) return value.length;
  if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
    return Object.keys(value).length;
  }
  return String(value).length;
};

// regex based validator template
var regex = exports.regex = function regex(value, expr) {
  return req(value) && expr.test(value);
};

var ref = exports.ref = function ref(prop, thisArg, object) {
  return typeof prop === 'function' ? prop.call(thisArg, object) : (0, _lodash2.default)(object, prop);
};